<template>
  <div>
    <!--
    <template>
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="300"
        >
          <json-view :data="$data" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <div class="blanco" style="margin-left:5%; width:90%;">
      <div class="divCol3">
        <v-row>
          <v-col>
            Nombre del Eje
            <span class="tRojo">*</span>
            <br />
            <v-text-field
              class="mt-0 pt-1"
              autofocus
              v-model.trim="editingEje.descripcion"
              background-color="white"
              maxlength="50"
              persistent-hint
              hint-align="right"
              dense
              :error="$v.editingEje.descripcion.$error"
              :hint="
                'CARACTERES RESTANTES ' +
                  serviceCommons.remaningCharacters(editingEje.descripcion, 50)
              "
              @keyup.enter="saveEje"
            >
              <template
                v-if="$v.editingEje.descripcion.$error || !isUniqueEje"
                v-slot:append
              >
                <v-popover placement="bottom-end" color="red" offset="16">
                  <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                  <template slot="popover">
                    <div
                      @click="$v.editingEje.descripcion.$reset"
                      v-close-popover
                    >
                      <div v-if="!$v.editingEje.descripcion.required">
                        ¡No te olvides de éste campo!
                      </div>
                      <div
                        @click="isUniqueEje = !isUniqueEje"
                        v-if="
                          !isUniqueEje && $v.editingEje.descripcion.required
                        "
                      >
                        ¡Encontramos su gemela! el nombre del eje esta duplicado
                      </div>
                    </div>
                  </template>
                </v-popover>
              </template>
            </v-text-field>
          </v-col>
        </v-row>
      </div>
      <div align="center">
        <v-row>
          <v-col>
            <template>
              <v-btn
                small
                class="mr-2"
                depressed
                dark
                tile
                color="secundary"
                @click="cancelChanges"
                >Cancelar cambios
              </v-btn>
              <v-btn
                :class="[
                  { desac: !hasGlobalChanges },
                  { 'error-validation-btn': false }
                ]"
                @click="saveEje"
                small
                depressed
                dark
                tile
                color="primary"
                >Guardar cambios</v-btn
              >
            </template>
          </v-col>
        </v-row>
      </div>
    </div>
    <template>
      <v-dialog v-model="dialogCancel" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¿Seguro que deseas
              <strong>cancelar</strong> los cambios realizados?
              <v-btn
                color="secondary"
                icon
                dark
                @click="dialogCancel = false"
                style="position: absolute;right: 0px;top: 0px;"
              >
                <v-icon>mdi-close</v-icon>
              </v-btn>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogCancel = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="cancelTempEditEje"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal" style=" text-align: center;">
              ¡Se han
              <strong
                >guardado los cambios del eje "{{ editingEje.descripcion }}" de
                manera exitosa!</strong
              >
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="finishEditingEje()"
                >De acuerdo</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSaveNew" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal" style=" text-align: center;">
              ¡Se ha
              <strong
                >guardado el eje {{ editingEje.descripcion }} de manera
                exitosa!</strong
              >
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="finishEditingEje()"
                >De acuerdo</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogDuplicateData" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong> ¡El eje ya se encuentra registrado! </strong>
              Por favor ingresa uno diferente.
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="dialogDuplicateData = false"
                >De acuerdo</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog
        v-model="dialogErrorValidationNombreEje"
        persistent
        max-width="600px"
      >
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Ocurrio un error al validar el nombre del eje
            </div>
          </v-card-title>
          <v-card-text
            >¡No hay de que preocuparse! Ya estamos trabajando en ello,
            estaremos de regreso pronto.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidationNombreEje = false"
                >¡De acuerdo!</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<script>
import axios from "axios";
import store from "@/store";
import { required } from "vuelidate/lib/validators";
const serviceCommons = store.state.serviceCommons;
export default {
  props: ["data", "metadata", "finishEditingEje"],
  name: "Eje",
  data() {
    return {
      dialogErrorValidation: false,
      editingEje: null,
      editingEjeBackup: null,
      dialogSave: false,
      dialogSaveNew: false,
      dialogDuplicateData: false,
      dialogCancel: false,
      dialogErrorValidationNombreEje: false,
      isUniqueEje: true
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    hasGlobalChanges() {
      if (this.editingEjeBackup) {
        const originalValue = JSON.stringify(this.editingEjeBackup).replace(
          /"/g,
          ""
        );
        const currentValue = JSON.stringify(this.editingEje).replace(/"/g, "");
        if (this.editingEje.id_eje === undefined) {
          if (originalValue !== currentValue) {
            return originalValue !== currentValue;
          }
          return originalValue === currentValue;
        }
        return originalValue !== currentValue;
      } else {
        return this.editingEje.id_eje === undefined;
      }
    }
  },
  validations: {
    editingEje: {
      descripcion: {
        required
      }
    }
  },
  methods: {
    getIndexEjeFromMetadata(id_eje) {
      let indexEjeOut;
      if (this.metadata.ejes) {
        this.metadata.ejes.forEach((itemEje, indexEje) => {
          if (itemEje.id_eje === id_eje) {
            indexEjeOut = indexEje;
          }
        });
      }
      return indexEjeOut;
    },
    setTempEditingEje() {
      this.editingEje = this.data;
      this.editingEjeBackup = JSON.parse(JSON.stringify(this.editingEje));
    },
    setEditingEje(data) {
      this.editingEje = this.data;
      this.editingEjeBackup = JSON.parse(JSON.stringify(this.editingEje));
    },
    cancelChanges() {
      this.dialogCancel = this.hasGlobalChanges;
      if (!this.hasGlobalChanges) {
        this.cancelTempEditEje();
      }
    },
    async saveEje() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        const self = this;
        if (this.editingEje.id_eje) {
          const isEje = await this.existEje();
          if (!isEje) {
            axios
              .put("/eje/secure/put", this.editingEje)
              .then(response => {
                if (response) {
                  const data = response.data.data;
                  if (response.data.status_code === 200) {
                    if (data.updated) {
                      delete data.updated;
                      const indexEje = self.getIndexEjeFromMetadata(
                        data.id_eje
                      );
                      self.metadata.ejes[indexEje].descripcion =
                        data.descripcion;
                      self.dialogSave = true;
                    }
                  } else {
                    console.log("No Update");
                  }
                }
              })
              .catch(error => {
                console.log(error);
              })
              .finally(function() {});
          }
        } else {
          const isEje = await this.existEje();
          if (!isEje) {
            axios
              .post("/eje/secure/post", this.editingEje)
              .then(response => {
                if (response) {
                  const data = response.data.data;
                  if (response.data.status_code === 200) {
                    if (data.inserted) {
                      delete data.inserted;
                      self.setEditingEje(data);
                      self.metadata.ejes.push(data);
                      self.dialogSaveNew = true;
                    }
                  } else {
                    console.log("No Update");
                  }
                }
              })
              .catch(error => {
                console.log(error);
              })
              .finally(function() {});
          }
        }
      } else {
        this.dialogErrorValidation = true;
      }
    },
    async existEje() {
      if (
        this.editingEjeBackup.descripcion === this.editingEje.descripcion &&
        this.editingEje.id_eje
      ) {
        return await false;
      } else {
        const self = this;
        return await axios
          .get("/eje/secure/get/nombre?value=" + this.editingEje.descripcion)
          .then(response => {
            if (response) {
              if (response.data.status_code === 200) {
                const exist =
                  (response.data.track_code &&
                    response.data.track_code === 3006) === undefined;
                if (exist) {
                  self.dialogDuplicateData = true;
                  self.isUniqueEje = false;
                }
                return exist;
              } else {
                return false;
              }
            }
          })
          .catch(error => {
            console.log(error);
            return false;
          })
          .finally(function() {});
      }
    },
    cancelTempEditEje() {
      if (this.editingEje.id_eje) {
        let indexEje;
        this.metadata.ejes.forEach((itemEje, indexItemEje) => {
          if (itemEje.id_eje === this.editingEje.id_eje) {
            indexEje = indexItemEje;
            this.cancelTempEditEje = true;
          }
        });
        this.metadata.ejes[
          indexEje
        ].descripcion = this.editingEjeBackup.descripcion;
      }
      this.finishEditingEje();
    }
  },
  created() {
    this.setTempEditingEje();
  }
};
</script>
